<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>How To HTML Form With PHP JS Captcha Validation - The Ultimate Guide | Tutorial | { visibility: inherit; }</title>
<link rel="shortcut icon" href="/favicon.ico" type="image/x-icon">
<link href="/styles.css" rel="stylesheet" type="text/css" media="screen">
<link href="/styles-alt.css" rel="alternate stylesheet" type="text/css" media="screen" title="styles-alt">
</head>

<body id="code">
<div id="wrapper">
<div id="header"><?php include("../includes/heading.php"); ?></div>
<div id="nav">
<?php include("../includes/nav.php"); ?>
</div>
<div id="content">
<em id="date">1/03/2013</em>
<h1>How To HTML Form With PHP/JS/Captcha Validation - The Ultimate Guide!</h1>
<p>
	<a href="how-to-html-form-with-php-js-captcha-validation-demo.php">Here is a working Demo <b>&raquo;</b></a><br>
	<a href="zip/how-to-html-form-with-php-js-captcha-validation.zip">Download source ZIP file <b>&raquo;</b></a>
</p>
<p>How to build a html form with PHP (server side), JS (client side), a simple but effective captcha, that validates all the form fields, and secures your server from hijacking spam bots, that functions seamlessly?! This whole question is one BIG puzzle is it not? Well call me the "The Puzzle Man", because I just made it very easy and put all the peices of the puzzle together in one small nicely zipped up package. A special thanks to Sitepoint forum members <a href="http://hibbard.eu/">Pullo</a> and <a href="http://www.sitepoint.com/forums/member.php?282808-ScallioXTX">ScallioXTX</a> for helping me work out the PHP/JS kinks. And here are <a href="http://www.visibilityinherit.com/code/jquery-validation-demo.php">4 other demos</a> of different ways to display the JS validation errors.</p>

<h2>Awsesome Form Attributes!</h2>
<ul style="margin:0 0 1.2em;list-style-position:inside;">
	<li>Simple directions (relatively)</li>
	<li>Clean HTML/CSS code</li>
	<li>Easily editable PHP formmail code with detailed comments</li>
	<li>Simple but strong and effective PHP backend protection/validation</li>
	<li>JS (client side) eye candy validation</li>
	<li>Finally an easy but effective captcha</li>
	<li>Captcha displays and validates random numbers 1-5 (e.g. 2+3, 1+4, etc)</li>
	<li>Confirmation page</li>
	<li>If JS off PHP error page</li>
	<li>Nicely formated email</li>
	<li>Works in all browsers IE7+</li>
</ul>

<div class="spacerdiv"></div>
<h2>DIRECTIONS...</h2>

<h2>Step 1: Create 7 Pages</h2>
<ol style="list-style-position:inside;">
	<li><strong>html-form-page.php</strong> (AKA the page that holds your html form)</li>
	<li><strong>formmail-page.php</strong> (AKA the page that holds your PHP form processing code)</li>
	<li><strong>validate-captcha-page.php</strong> (AKA the page that holds the PHP that helps validate the captcha)</li>
	<li><strong>error-page.php</strong> (AKA the page that holds the error message if JS is bypassed)</li>
	<li><strong>confirmation-page.php</strong> (AKA the page that displays the successful form submission message)</li>
	<li><strong>jQuery-page.js</strong> (AKA the page that holds jQuery v1.8.3)</li>
	<li><strong>jQuery-validation-page.js</strong> (AKA the page that holds jQuery Validation Plugin v1.10.0)</li>
</ol>

<div class="spacerdiv"></div>

<h2>Step 2: Download JS dependencies</h2>
<p>
	<a href="jquery/jQuery1.8.3.js">jQuery v1.8.3</a><br>
	<a href="jquery/jQuery.validation.1.10.0.js">jQuery Validation Plugin v1.10.0</a>
</p>

<div class="spacerdiv"></div>

<h2>Step 3: html-form-page.php code</h2>
<p>Note: the PHP above the DOCTYPE and the PHP in the Captcha label is whats needed to enable the captcha to work. The JS is what's needed for the validation plugin to work. If you want messages to appear instead of just the red outline, remove label.error display none in the CSS and add the wanted messages to the "messages" section in the JS.</p>
<pre>
&lt;?php
session_start();
if (!isset($_SESSION['num1']) &amp;&amp; !isset($_SESSION['num2'])) {
$_SESSION['num1'] = rand(1,5);
$_SESSION['num2'] = rand(1,5);
}
?&gt;
&lt;!DOCTYPE html&gt;&lt;html&gt;&lt;head&gt;&lt;meta charset=&quot;UTF-8&quot;&gt;
&lt;title&gt;HTML Form Page&lt;/title&gt;
&lt;style type=&quot;text/css&quot;&gt;
<span>/* --- form css --- */</span>
form {
width:400px;
}
input, textarea, label {
display:inline-block;
margin:10px 5px;
width:150px;
vertical-align:middle;
padding:4px;
}
input, textarea {
border:1px solid #666;
box-shadow:0 0 4px #666;
border-radius:5px;
}
label {
text-align:right;
}
#submit {
margin-left:177px;
width:160px;
background:#ddd;
cursor:pointer;
}
<span>/* --- error css --- */</span>
input.error, textarea.error {
border:1px solid red;
box-shadow:0 0 4px red;
}
label.error {
display:none !important;
}
input.error, textarea.error {
-moz-animation:glow ease-in infinite alternate 500ms;
-webkit-animation:glow ease-in infinite alternate 500ms;
-ms-animation:glow ease-in infinite alternate 500ms;
animation:glow ease-in infinite alternate 500ms;
}
@-moz-keyframes glow {0%{box-shadow:0 0 4px red;}100%{box-shadow:0 0 9px red;}}
@-webkit-keyframes glow {0%{box-shadow:0 0 4px red;}100%{box-shadow:0 0 9px red;}}
@-ms-keyframes glow {0%{box-shadow:0 0 4px red;}100%{box-shadow:0 0 9px red;}}
@keyframes glow {0%{box-shadow:0 0 4px red;}100%{box-shadow:0 0 9px red;}}
&lt;/style&gt;
&lt;/head&gt;
&lt;body&gt;

&lt;form method=&quot;post&quot; action=&quot;how-to-html-form-with-php-js-captcha-validation-formmail.php&quot;&gt;
	&lt;label for=&quot;name&quot;&gt;Name&lt;/label&gt;
	&lt;input type=&quot;text&quot; id=&quot;name&quot; name=&quot;name&quot; placeholder=&quot;Name&quot;&gt;
	&lt;br&gt;
	&lt;label for=&quot;email&quot;&gt;Email&lt;/label&gt;
	&lt;input type=&quot;text&quot; maxlength=&quot;50&quot; id=&quot;email&quot; name=&quot;email&quot; placeholder=&quot;Email&quot;&gt;
	&lt;br&gt;
	&lt;label for=&quot;comments&quot;&gt;Comments&lt;/label&gt;
	&lt;textarea id=&quot;comments&quot; name=&quot;comments&quot; rows=&quot;1&quot; cols=&quot;1&quot; placeholder=&quot;Comments&quot;&gt;&lt;/textarea&gt;
	&lt;br&gt;
	&lt;label for=&quot;captcha&quot;&gt;&lt;?php echo $_SESSION['num1']; ?&gt;+ &lt;?php echo $_SESSION['num2']; ?&gt;?&lt;/label&gt;
	&lt;input type=&quot;text&quot; id=&quot;captcha&quot; name=&quot;captcha&quot; placeholder=&quot;Captcha&quot;&gt;
	&lt;br&gt;
	&lt;input type=&quot;submit&quot; name=&quot;submit&quot; value=&quot;Submit&quot; id=&quot;submit&quot;&gt;
&lt;/form&gt;

&lt;script src=&quot;jquery/jQuery1.8.3.js&quot;&gt;&lt;/script&gt;
&lt;script src=&quot;jquery/jQuery.validation.1.10.0.js&quot;&gt;&lt;/script&gt;
&lt;script type=&quot;text/javascript&quot;&gt;
$(document).ready(function() {
  $.validator.addMethod(&quot;nourl&quot;, function(value, element) {
    return !/http://|www.|link=|url=/.test(value);
  }, &quot;No URL's&quot;);

  $(&quot;form&quot;).validate({
    rules: {
      name: {
        required: true
      },
      email: {
        required: true,
        email: true
      },
      comments: {
        required: true,
        minlength: 4,
        nourl: true
      },
      captcha: {
        required: true,
        remote: {
          url: &quot;validation-captcha-page.php&quot;,
          type: &quot;post&quot;
        }
      }
    },
    messages: {
		name: &quot;&quot;,
		email: &quot;&quot;,
		comments: &quot;&quot;,
		captcha: &quot;&quot;
		}
  });
});
&lt;/script&gt;
&lt;/body&gt;&lt;/html&gt;
</pre>

<div class="spacerdiv"></div>

<h2>Step 4: formmail-page.php code</h2>
<pre>
&lt;?php
<span>// =======================================================================
// NOTE: In the 3 places below that are wrapped in comments exactly like
// the ones wrapping this sentence INSERT YOUR specific information
// Author: Eric Watson @ http://www.visibilityinherit.com
// =======================================================================</span>

<span>// Prevent browser cache</span>
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache"); 

<span>// Remove headers</span>
function remove_headers($string) { 
  $headers = array(
    "/to\:/i",
    "/from\:/i",
    "/bcc\:/i",
    "/cc\:/i",
    "/Content\-Transfer\-Encoding\:/i",
    "/Content\-Type\:/i",
    "/Mime\-Version\:/i" 
  ); 
  if (preg_replace($headers, '', $string) == $string) {
    return $string;
  } else {
    die('');
  }
}

<span>// Separate headers by either \r\n or \n to ensure email sends properly</span>
$uself = 0;
$headersep = (!isset( $uself ) || ($uself == 0)) ? "\r\n" : "\n" ;

   
<span>// =======================================================================</span>
<span>// Insert your information and correct link paths here</span>
$mailto = 'your@email.com' ;
$from = "Your Business Name Formmail" ;
$formurl = "formmail-page.php" ;
$errorurl = "errorpage.php" ;
$thankyouurl = "confirmation-page.php" ;
<span>// =======================================================================</span>

<span>// =======================================================================</span>
<span>// Add or remove your specific Form variables here</span>
$name = remove_headers($_POST['name']);
$email = remove_headers($_POST['email']);
$comments = remove_headers($_POST['comments']);
$spam = remove_headers($_POST['captcha']);
$http_referrer = getenv( "HTTP_REFERER" );
<span>// =======================================================================</span>

<span>// =======================================================================
// Un-comment if you want to add/clean PHONE to form
// if (preg_match("{[A-Za-z]}", $phone))
// {
//   header( "Location: $errorurl" );
//	exit ;
// }
// =======================================================================</span>

<span>// If name or email contain carriage returns or new line characters stop execution and direct to errorurl</span>
if ( ereg( "[\r\n]", $name ) || ereg( "[\r\n]", $email ) ) {
	header( "Location: $errorurl" );
	exit ;
}

<span>// Clean Email - if empty ignore - if value in form input clean</span>
if (!empty($email) && !preg_match("/^[A-Z0-9._%-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$/i",$email)) { 
    header( "Location: $errorurl" );
    exit ;
}  

<span>// Clean Comments</span>
if (get_magic_quotes_gpc()) {
	$comments = stripslashes( $comments );
}

<span>// Clean Comments - max 1250 characters</span>
if (strlen($comments) > 1250) {
$comments=substr($comments, 0, 1250).'...';
}

<span>// Clean Comments - no URL's</span>
if (preg_match("{link=}", $comments) || preg_match("{url=}", $comments) || preg_match("{http://}", $comments))
{
    header( "Location: $errorurl" );
	exit ;
}

<span>// Make Name, Email, and Comments required before form submission</span>
if (empty($name) || empty($email) ||empty($comments)) {
	header( "Location: $errorurl" );
	exit ;
}

<span>// Clean Captcha: random numbers 1 through 5 (1+3, 4+2, 5+3, etc)</span>
session_start();
if (!isset($_SESSION['num1']) || !isset($_SESSION['num2'])) {
	<span>// no known session. cannot validate captcha</span>
    header( "Location: $errorurl" );
    exit;
}
$sum = (int)$_SESSION['num1'] + (int)$_SESSION['num2'];
if (isset($_POST['captcha']) && (int)$_POST['captcha'] !== $sum) {
	<span>// captcha given but incorrect</span>
    header( "Location: $errorurl" );
    exit;
} else {
	<span>// captcha correct, show a new one next time</span>
	unset($_SESSION['num1'], $_SESSION['num2']);
}

<span>// Send Message</span>
$message =
	"This message was sent from:\n" .
	"$http_referrer\n\n" .
<span>// =======================================================================</span>
<span>// Add or remove your specific Form variables here</span>
	"Name: $name\n\n" .
	"Email: $email\n\n" .
	"Comments: $comments\n\n" .
<span>// =======================================================================</span>
	"Captcha: $captcha\n\n" .
	"\n\n------------------------------------------------------------\n" ;

mail($mailto, $from, $message,
	"From: \"$name\" &lt;$email&gt;" . $headersep . "Reply-To: \"$name\" &lt;$email&gt;" . $headersep );
header( "Location: $thankyouurl" );
exit ;

?&gt;
</pre>

<div class="spacerdiv"></div>

<h2>Step 5: validate-captcha-page.php code</h2>
<p>This is the PHP page that is called by the "remote" rule in the validation plugin to help validate the captcha.</p>
<pre>
&lt;?php
session_start();
if (!isset($_SESSION['num1']) || !isset($_SESSION['num2'])) {
    exit('"Unknown session"');
}
$sum = (int)$_SESSION['num1'] + (int)$_SESSION['num2'];
if (isset($_POST['captcha']) && (int)$_POST['captcha'] === $sum) {
    exit('true');
}
exit('false');
?&gt;
</pre>

<div class="spacerdiv"></div>

<h2>Step 6: error-page.php code</h2>
<p>This is the error page that is shown if JS is off and PHP validates the form instead.</p>
<pre>
&lt;!DOCTYPE html&gt;&lt;html&gt;&lt;head&gt;&lt;meta charset=&quot;UTF-8&quot;&gt;
&lt;title&gt;Error Page&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;
&lt;h1&gt;Error&lt;/h1&gt;
&lt;p&gt;Oops sorry, there was an error in the information you entered. You either failed to fill in all of the required&lt;br&gt; information, or made a mistake while typing. You may try again by using the back button in your browser.&lt;/p&gt;
&lt;/body&gt;&lt;/html&gt;
</pre>

<div class="spacerdiv"></div>

<h2>Step 7: confirmation-page.php code</h2>
<p>This is the messages displayed to the user after a successful form submission.</p>
<pre>
&lt;!DOCTYPE html&gt;&lt;html&gt;&lt;head&gt;&lt;meta charset=&quot;UTF-8&quot;&gt;
&lt;title&gt;Confirmation Page&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;
&lt;h1&gt;Thank you! Message recieved. We will get back to you shortly...&lt;/h1&gt;
&lt;/body&gt;&lt;/html&gt;
</pre>

<div class="spacerdiv"></div>

<h2>DONE! Message in your email box looks like this...</h2>
<pre>
This message was sent from http://www.your-webpage.com

Name: Eric Watson

Email: eric@gmail.com

Comments: Hello Eric, this tutorial is amazing!

Captcha: 8
</pre>

<?php include("http://www.visibilityinherit.com/includes/paypal.php"); ?>
<?php include("http://www.visibilityinherit.com/includes/disqus.php"); ?>
<?php include("http://www.visibilityinherit.com/includes/search.php"); ?>
</div>
<div id="clearfooter"></div>
<?php include("http://www.visibilityinherit.com/includes/ads.php"); ?>
</div>
<div id="footer">
<div id="footerborder"></div>
<?php include("../includes/footer.php"); ?>
</div>
<script src="/javascript/styleswitch.js" type="text/javascript"></script>
</body>
</html>